/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package DB;

import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author swinkx
 */
public class Connection {
    
    java.sql.Connection conn = null; //adatbázis kapcsolat
    Statement stmt; //sql statement
    String dbName = "firstDB";  //adatbázis neve
    String username = "p";      //felhasznév
    String passwd = "a";        //jelszó
    
    private Connection(){
        try {
            //betöltjük a driver-t, nem példány! (szükséges: derbyclient.jar)
            Class.forName("org.apache.derby.jdbc.ClientDriver");
            //csatlakozunk a derby szerverhez!
            conn = DriverManager.getConnection("jdbc:" + "derby" + ":" + "//localhost:1527/" + dbName , username, passwd);
            stmt = conn.createStatement();//létrehozunk egy statementet
        } catch (SQLException ex) {
            Logger.getLogger(Connection.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(Connection.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    //singleton minta
    public static Connection getInstance(){
        return ConnectionHolder.INSTANCE;
    }
    
    //Itt tároljuk az egyetlen példányunkat
    private static class ConnectionHolder{
        private static final Connection INSTANCE = new Connection();
    }
    
    //Lekérdezésekhez használd ezt, visszaadja az eredményt(ResultSet)
    public ResultSet executeQuery(String query){
        try {
            ResultSet rs = stmt.executeQuery(query);
            return rs;
        } catch (SQLException ex) {
            Logger.getLogger(Connection.class.getName()).log(Level.SEVERE, null, ex);
            return null;
        }
    }
    
    //SQL INSERT, UPDATE, DELETE edetén használd ezt! visszaadja, hogy hány sor módosult
    public int executeUpdate(String query){
        try {
            return stmt.executeUpdate(query);
        } catch (SQLException ex) {
            Logger.getLogger(Connection.class.getName()).log(Level.SEVERE, null, ex);
        }
        return -1;
    }
    
    //lezárja/érvényesíti a tranzakcíót
    public void commit(){
        try {
            conn.commit();
        } catch (SQLException ex) {
            Logger.getLogger(Connection.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    //kapcsolat bontása!
    public void close(){
        try {
            conn.close();
        } catch (SQLException ex) {
            Logger.getLogger(Connection.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
}
