/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package GUI;

import DB.DataCallback;
import DB.Logic;
import DB.Teacher;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.LinkedList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author swinkx
 */
public class TeacherTable  implements DataCallback{
    private JTable table;
    private MyTableModel myTAbleModel;
    
    public TeacherTable(Logic logic){
        myTAbleModel = new MyTableModel();
        table = new JTable(myTAbleModel);
        table.setAutoCreateRowSorter(true);
        
        //select
       requestData(logic);
    }
    
    private void requestData(Logic logic){
        //utasítjuk a logikai réteget, hogy futassa le ezt a selectet,egy külön szálon
        //Majd ha elkészült, hívja meg ezen osztály DataArrived függvényét
        logic.requestData("select TEACHER_ID,FIRST_NAME,LAST_NAME from P.TEACHER", this);
    }
     
    public JTable getTable(){
        return table;
    }

    /**
     * Ha megérkezett minden adat, akkor ez a függvény hívódik meg.
     * @param rs - a korábbi select eredménye - ha semmi hiba sem történt
     */
    @Override
    public void DataArrived(ResultSet rs) {
         try {
            while(rs.next()){//minden sort feldolgozunk
                int id = rs.getInt(1);//rs.getInt("TEACHER_ID");
                
                String fname = rs.getString("FIRST_NAME");
                String lname = rs.getString("LAST_NAME");
                myTAbleModel.addTeacher(new Teacher(id, fname, lname));
            }
        } catch (SQLException ex) {
            Logger.getLogger(TeacherTable.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
     
    private class MyTableModel extends AbstractTableModel{
        private String[] columns = {"ID", "First Name", "Second Name"};
        
        private List<Teacher> data = new LinkedList<Teacher>();
        
        public void addTeacher(Teacher t){
            data.add(t);
            fireTableDataChanged();
        }
        
        //kötelező felülírni
        @Override
        public int getRowCount() {
            return data.size();
        }

        //kötelező felülírni
        @Override
        public int getColumnCount() {
            return columns.length;
        }

        //kötelező felülírni
        @Override
        public Object getValueAt(int arg0, int arg1) {
            Teacher t = data.get(arg0);
            switch(arg1){
                case 0:
                    return t.getTeacherID();
                case 1:
                    return t.getFirstName();
                case 2:
                    return t.getLastName();
                default:
                    return null;
            }
        }
        
        //A következőket már nem muszáj felülírni, de ajánlott, hiszen:
        
        //Ez szükséges, hogy legyen az oszlopainknak neve
        @Override
        public String getColumnName(int col) {
            return columns[col];
        }
        
        //A megfelelő megjelenítéshez szüksgéges(checkbox/integer)
        @Override
        public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
        }
        
        //alapból nem lehet változtatni a táblázat értékeit.
        @Override
        public boolean isCellEditable(int row, int col) {   
            if (col < 2) {
                return false;
            } else {
                return true;
            }
        }
        
        //Ha ezt nem írjuk felül, akkor nem menti a változtatásokat
        @Override
        public void setValueAt(Object value, int row, int col) {
            Teacher t = data.get(row);
            switch(col){
                case 0:
                    t.setTeacherID((Integer)value);
                case 1:
                    t.setFirstName((String)value);
                case 2:
                    t.setLastName((String)value);
                default:
                    ;
            }
            fireTableCellUpdated(row,col);//Ez értesíti az összes listenert( a TableModelListener is), hogy változás történt
            
            //fireTableDataChanged();//itt jelezhetjük, hogy a (teljes) táblázat változott, ezért azt újra kell rajzolni!
        }
    }
}
