package swingschooljdbc.gui;

import java.awt.BorderLayout;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import swingschooljdbc.gui.tablemodels.*;

public class SwingSchoolFrame extends JFrame {

    public static void showError(String message) {
        JOptionPane.showMessageDialog(null, message, "Error", JOptionPane.ERROR_MESSAGE);
    }

    private JTable subjectTable, studentTable, teacherTable, grouppTable, subjTeachTable, markTable;
    private SubjectTableModel subjectTableModel;
    private TeacherTableModel teacherTableModel;
    private StudentTableModel studentTableModel;
    private GrouppTableModel grouppTableModel;
    private SubjTeachTableModel subjTeachTableModel;
    private MarkTableModel markTableModel;

    public SwingSchoolFrame() {
        setTitle("School");
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        setLocation(30, 30);
        setSize(600, 400);
        setJMenuBar(createJMenuBar());
        JTabbedPane jTabbedPane = new JTabbedPane();
        getContentPane().add(jTabbedPane, BorderLayout.CENTER);

        subjectTableModel = new SubjectTableModel();
        subjectTable = new JTable(subjectTableModel);
        subjectTable.setAutoCreateRowSorter(true);
        jTabbedPane.addTab("Subjects", new JScrollPane(subjectTable));
        
        studentTableModel = new StudentTableModel();
        studentTable = new JTable(studentTableModel);
        studentTable.setAutoCreateRowSorter(true);
        jTabbedPane.addTab("Students", new JScrollPane(studentTable));
        
        teacherTableModel = new TeacherTableModel();
        teacherTable = new JTable(teacherTableModel);
        teacherTable.setAutoCreateRowSorter(true);
        jTabbedPane.add("Teachers", new JScrollPane(teacherTable));
        
        grouppTableModel = new GrouppTableModel();
        grouppTable = new JTable(grouppTableModel);
        grouppTable.setAutoCreateRowSorter(true);
        jTabbedPane.add("Groups", new JScrollPane(grouppTable));
        
        subjTeachTableModel = new SubjTeachTableModel();
        subjTeachTable = new JTable(subjTeachTableModel);
        subjTeachTable.setAutoCreateRowSorter(true);
        jTabbedPane.add("Group assignments", new JScrollPane(subjTeachTable));
        
        markTableModel = new MarkTableModel();
        markTable = new JTable(markTableModel);
        markTable.setAutoCreateRowSorter(true);
        jTabbedPane.add("Marks", new JScrollPane(markTable));
    }

    private JMenuBar createJMenuBar() {
        JMenuBar jMenuBar = new JMenuBar();
        JMenu jMenu;
        
        jMenu = new JMenu("Subjects");
        jMenuBar.add(jMenu);
        //jMenu.add(addSubjectAction);
        //jMenu.add(deleteSubjectsAction);
        
        return jMenuBar;
    }
}
