package swingschooljdbc.gui.tablemodels;

import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.table.AbstractTableModel;
import swingschooljdbc.gui.SwingSchoolFrame;
import swingschooljdbc.logic.DataSource;
import swingschooljdbc.logic.entities.Groupp;

public class GrouppTableModel extends AbstractTableModel{

    @Override
    public int getRowCount() {
        try {
            return DataSource.getInstance().getGrouppController().getGrouppCount();
        } catch (SQLException ex) {
            SwingSchoolFrame.showError(ex.getMessage());
            return 0;
        }
    }

    @Override
    public int getColumnCount() {
        return Groupp.fieldNames.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        Groupp groupp;
        try {
            groupp = DataSource.getInstance().getGrouppController().getGroupp(rowIndex);
        } catch (SQLException ex) {
            SwingSchoolFrame.showError(ex.getMessage());
            return "?";
        }
        return groupp.getName();
    }
    
}
