package swingschooljdbc.gui.tablemodels;

import java.sql.SQLException;
import javax.swing.table.AbstractTableModel;
import swingschooljdbc.gui.SwingSchoolFrame;
import swingschooljdbc.logic.DataSource;
import swingschooljdbc.logic.entities.Student;

public class StudentTableModel extends AbstractTableModel {

    @Override
    public int getRowCount() {
        try {
            return DataSource.getInstance().getStudentController().getStudentCount();
        } catch (SQLException ex) {
            SwingSchoolFrame.showError(ex.getMessage());
            return 0;
        }
    }

    @Override
    public int getColumnCount() {
        return Student.fieldNames.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        Student student;
        try {
            student = DataSource.getInstance().getStudentController().getStudent(rowIndex);
        } catch (SQLException ex) {
            SwingSchoolFrame.showError(ex.getMessage());
            return "?";
        }
        switch (columnIndex) {
            case 0:
                return student.getFirstName();
            case 1:
                return student.getLastName();
            case 2:
                return student.getGroupp().getName();
            default:
                return null;
        }
    }

    @Override
    public String getColumnName(int column) {
        return Student.fieldNames[column];
    }

    @Override
    public Class<?> getColumnClass(int columnIndex) {
        return String.class;
    }
}
