package swingschooljdbc.gui.tablemodels;

import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.table.AbstractTableModel;
import swingschooljdbc.gui.SwingSchoolFrame;
import swingschooljdbc.logic.DataSource;
import swingschooljdbc.logic.entities.SubjTeach;

public class SubjTeachTableModel extends AbstractTableModel {

    @Override
    public int getRowCount() {
        try {
            return DataSource.getInstance().getSubjTeachController().getSubjTeachCount();
        } catch (SQLException ex) {
            SwingSchoolFrame.showError(ex.getMessage());
            return 0;
        }
    }

    @Override
    public int getColumnCount() {
        return SubjTeach.fieldNames.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        SubjTeach subjTeach;
        try {
            subjTeach = DataSource.getInstance().getSubjTeachController().getSubjTeach(rowIndex);
        } catch (SQLException ex) {
            SwingSchoolFrame.showError(ex.getMessage());
            return "?";                   
        }
        switch(columnIndex){
            case 0: return subjTeach.getTeacher().getFirstName()+" "+subjTeach.getTeacher().getLastName();
            case 1: return subjTeach.getSubject().getTitle();
            case 2: return subjTeach.getGroupp().getName();
            default: return null;
        }
    }

    @Override
    public Class<?> getColumnClass(int columnIndex) {
        return String.class;
    }

    @Override
    public String getColumnName(int column) {
        return SubjTeach.fieldNames[column];
    }
    
}
