package swingschooljdbc.gui.tablemodels;

import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.table.AbstractTableModel;
import swingschooljdbc.gui.SwingSchoolFrame;
import swingschooljdbc.logic.DataSource;
import swingschooljdbc.logic.entities.Teacher;

public class TeacherTableModel extends AbstractTableModel{

    @Override
    public int getRowCount() {
        try {
            return DataSource.getInstance().getTeacherController().getTeacherCount();
        } catch (SQLException ex) {
            SwingSchoolFrame.showError(ex.getMessage());
            return 0;
        }
    }

    @Override
    public int getColumnCount() {
        return Teacher.fieldNames.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        Teacher teacher;
        try {
            teacher = DataSource.getInstance().getTeacherController().getTeacher(rowIndex);
        } catch (SQLException ex) {
            SwingSchoolFrame.showError(ex.getMessage());
            return "?";
        }
        return columnIndex == 0 ? teacher.getFirstName() : teacher.getLastName();
    }

    @Override
    public Class<?> getColumnClass(int columnIndex) {
        return String.class;
    }

    @Override
    public String getColumnName(int column) {
        return Teacher.fieldNames[column];
    }
    
}
