package swingschooljdbc.logic;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import swingschooljdbc.logic.controllers.*;

public class DataSource {

    private String url, //connection string
            username, password;
    private GrouppController grouppController;
    private StudentController studentController;
    private TeacherController teacherController;
    private SubjectController subjectController;
    private SubjTeachController subjTeachController;
    private MarkController markController;

    private DataSource() {
        url = "jdbc:derby://localhost:1527/School";
        username = "root";
        password = "root";
        grouppController = new GrouppController();
        studentController = new StudentController();
        teacherController = new TeacherController();
        subjectController = new SubjectController();
        subjTeachController = new SubjTeachController();
        markController = new MarkController();
    }

    public Connection getConnection() throws SQLException {
        return DriverManager.getConnection(url, username, password);
    }

    public GrouppController getGrouppController() {
        return grouppController;
    }

    public StudentController getStudentController() {
        return studentController;
    }

    public TeacherController getTeacherController() {
        return teacherController;
    }

    public SubjectController getSubjectController() {
        return subjectController;
    }

    public SubjTeachController getSubjTeachController() {
        return subjTeachController;
    }

    public MarkController getMarkController() {
        return markController;
    }

    public static DataSource getInstance() {
        return DataSourceHolder.INSTANCE;
    }

    private static class DataSourceHolder {

        private static final DataSource INSTANCE = new DataSource();
    }
}
