package swingschooljdbc.logic.controllers;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import swingschooljdbc.logic.DataSource;
import swingschooljdbc.logic.entities.Mark;

public class MarkController {
    public int getMarkCount() throws SQLException {
        int markCount;
        try (
                Connection connection = DataSource.getInstance().getConnection();
                Statement statement = connection.createStatement();
                ResultSet resultSet = statement.executeQuery("SELECT COUNT(*) AS CNT FROM MARK");) {
            resultSet.next();
            markCount = resultSet.getInt("CNT");
        }
        return markCount;
    }

    public Mark getMark(int rowIndex) throws SQLException {
        Mark mark = new Mark();
        int studentId, subjectId;
        try (
                Connection connection = DataSource.getInstance().getConnection();
                Statement statement = connection.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
                ResultSet resultSet = statement.executeQuery("SELECT * FROM MARK");) {
            resultSet.absolute(rowIndex + 1);
            mark.setMarkId(resultSet.getInt(1));
            studentId = resultSet.getInt(2);
            subjectId = resultSet.getInt(3);
            mark.setDate(resultSet.getDate(4));
            mark.setMark(resultSet.getInt(5));
        }
        mark.setSubject(DataSource.getInstance().getSubjectController().getSubjectById(subjectId));
        mark.setStudent(DataSource.getInstance().getStudentController().getStudentById(studentId));
        return mark;
    }
    
}
