package swingschooljdbc.logic.controllers;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import swingschooljdbc.logic.DataSource;
import swingschooljdbc.logic.entities.Groupp;
import swingschooljdbc.logic.entities.Student;

public class StudentController {
    public int getStudentCount() throws SQLException {
        int studentCount;
        try (
                Connection connection = DataSource.getInstance().getConnection();
                Statement statement = connection.createStatement();
                ResultSet resultSet = statement.executeQuery("SELECT COUNT(*) AS CNT FROM STUDENT");) {
            resultSet.next();
            studentCount = resultSet.getInt("CNT");
        }
        return studentCount;
    }

    public Student getStudent(int rowIndex) throws SQLException {
        Student student = new Student();
        int groupId;
        try (
                Connection connection = DataSource.getInstance().getConnection();
                Statement statement = connection.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
                ResultSet resultSet = statement.executeQuery("SELECT * FROM STUDENT");) {
            resultSet.absolute(rowIndex + 1);
            student.setStudentId(resultSet.getInt(1));
            student.setFirstName(resultSet.getString(2));
            student.setLastName(resultSet.getString(3));
            groupId = resultSet.getInt(4);
        }
        Groupp group = DataSource.getInstance().getGrouppController().getGroupById(groupId);
        student.setGroupp(group);
        return student;
    }

    Student getStudentById(int studentId) throws SQLException {
        Student student = new Student();
        int groupId;
        try (
                Connection connection = DataSource.getInstance().getConnection();
                Statement statement = connection.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
                ResultSet resultSet = statement.executeQuery("SELECT * FROM STUDENT WHERE STUDENT_ID = "+studentId);) {
            resultSet.next();
            student.setStudentId(resultSet.getInt(1));
            student.setFirstName(resultSet.getString(2));
            student.setLastName(resultSet.getString(3));
            groupId = resultSet.getInt(4);
        }
        Groupp group = DataSource.getInstance().getGrouppController().getGroupById(groupId);
        student.setGroupp(group);
        return student;
    }    
}
