package swingschooljdbc.logic.controllers;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import swingschooljdbc.logic.DataSource;
import swingschooljdbc.logic.entities.SubjTeach;

public class SubjTeachController {

    public int getSubjTeachCount() throws SQLException {
        int subjTeachCount;
        try (
                Connection connection = DataSource.getInstance().getConnection();
                Statement statement = connection.createStatement();
                ResultSet resultSet = statement.executeQuery("SELECT COUNT(*) AS CNT FROM SUBJ_TEACH");) {
            resultSet.next();
            subjTeachCount = resultSet.getInt("CNT");
        }
        return subjTeachCount;
    }

    public SubjTeach getSubjTeach(int rowIndex) throws SQLException {
        SubjTeach subjTeach = new SubjTeach();
        int grouppId, subjectId, teacherId;
        try (
                Connection connection = DataSource.getInstance().getConnection();
                Statement statement = connection.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
                ResultSet resultSet = statement.executeQuery("SELECT * FROM SUBJ_TEACH");) {
            resultSet.absolute(rowIndex + 1);
            subjTeach.setStId(resultSet.getInt(1));
            subjectId = resultSet.getInt(2);
            teacherId = resultSet.getInt(3);
            grouppId = resultSet.getInt(4);
        }
        subjTeach.setGroupp(DataSource.getInstance().getGrouppController().getGroupById(grouppId));
        subjTeach.setSubject(DataSource.getInstance().getSubjectController().getSubjectById(subjectId));
        subjTeach.setTeacher(DataSource.getInstance().getTeacherController().getTeacherById(teacherId));
        return subjTeach;
    }
}
